"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    /**
 * @description Create a one-time modal dialog dynamically without maintenance loading and visible.
 * @description.zh-CN 动态创建一次性的模态框，不需要维护 loading 和 visible。
 */ default: function() {
        return createModal;
    },
    createFunctionWithDefaultProps: function() {
        return createFunctionWithDefaultProps;
    }
});
const _react = /*#__PURE__*/ _interop_require_wildcard(require("react"));
const _client = require("react-dom/client");
const _antd = require("antd");
function _getRequireWildcardCache(nodeInterop) {
    if (typeof WeakMap !== "function") return null;
    var cacheBabelInterop = new WeakMap();
    var cacheNodeInterop = new WeakMap();
    return (_getRequireWildcardCache = function(nodeInterop) {
        return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
    })(nodeInterop);
}
function _interop_require_wildcard(obj, nodeInterop) {
    if (!nodeInterop && obj && obj.__esModule) {
        return obj;
    }
    if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
        return {
            default: obj
        };
    }
    var cache = _getRequireWildcardCache(nodeInterop);
    if (cache && cache.has(obj)) {
        return cache.get(obj);
    }
    var newObj = {};
    var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for(var key in obj){
        if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
            var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
            if (desc && (desc.get || desc.set)) {
                Object.defineProperty(newObj, key, desc);
            } else {
                newObj[key] = obj[key];
            }
        }
    }
    newObj.default = obj;
    if (cache) {
        cache.set(obj, newObj);
    }
    return newObj;
}
function App({ content , children =content , render , onOk , onCancel , onFailed , // onDeny,
// denyText,
// hideCancel = false,
// hideOk = false,
...rest }) {
    const formLikeRef = (0, _react.useRef)();
    const [visible, setVisible] = (0, _react.useState)(false);
    // const { /* direction, */ getPrefixCls } = React.useContext(ConfigContext);
    // const prefixCls = getPrefixCls('modal');
    // const rootPrefixCls = getPrefixCls();
    const [confirmLoading, setConfirmLoading] = (0, _react.useState)(false);
    (0, _react.useEffect)(()=>{
        // for animation
        setVisible(true);
    }, []);
    const handleOk = async ()=>{
        setConfirmLoading(true);
        try {
            var _formLikeRef_current, _formLikeRef_current1;
            const validateFields = ((_formLikeRef_current = formLikeRef.current) === null || _formLikeRef_current === void 0 ? void 0 : _formLikeRef_current.validateFieldsReturnFormatValue) || ((_formLikeRef_current1 = formLikeRef.current) === null || _formLikeRef_current1 === void 0 ? void 0 : _formLikeRef_current1.validateFields);
            const values = await (validateFields === null || validateFields === void 0 ? void 0 : validateFields());
            await (onOk === null || onOk === void 0 ? void 0 : onOk(values));
            setVisible(false);
        } catch (error) {
            // console.error(error);
            onFailed === null || onFailed === void 0 ? void 0 : onFailed(error);
        // throw error;
        } finally{
            setConfirmLoading(false);
        }
    };
    // const handleDeny = async () => {
    //   setConfirmLoading(true);
    //   try {
    //     const validateFields =
    //       formLikeRef.current?.validateFieldsReturnFormatValue || formLikeRef.current?.validateFields;
    //     const values = await validateFields?.();
    //     await onDeny?.(values);
    //     setVisible(false);
    //   } catch (error) {
    //     onFailed?.(error);
    //     console.error(error);
    //     // throw error;
    //   } finally {
    //     setConfirmLoading(false);
    //   }
    // };
    const handleCancel = (e)=>{
        setVisible(false);
        onCancel === null || onCancel === void 0 ? void 0 : onCancel(e);
    };
    const renderPropChildren = ()=>{
        if (render) return render(formLikeRef);
        let attached = false;
        return _react.Children.map(children, (child)=>{
            if (!/*#__PURE__*/ (0, _react.isValidElement)(child)) {
                return child;
            }
            if (attached) return child;
            const childProps = {
                ...child.props,
                ref: formLikeRef
            };
            attached = true;
            return /*#__PURE__*/ _react.default.cloneElement(child, childProps);
        });
    };
    return(// <LocaleReceiver componentName="Modal">
    //   {(contextLocale) => (
    /*#__PURE__*/ _react.default.createElement(_antd.Modal, {
        ...rest,
        // todo context value and locale
        // todo extra footer buttons
        confirmLoading: confirmLoading,
        onCancel: handleCancel,
        onOk: handleOk,
        // okText={contextLocale.okText || contextLocale.justOkText}
        // cancelText={contextLocale.cancelText}
        // footer={[
        //   hideCancel || (
        //     <Button key="cancel" onClick={handleCancel}>
        //       {rest?.cancelText || '取消'}
        //     </Button>
        //   ),
        //   onDeny && (
        //     <Button key="deny" type="primary" danger loading={confirmLoading} onClick={handleDeny}>
        //       {denyText || '驳回'}
        //     </Button>
        //   ),
        //   hideOk || (
        //     <Button key="ok" type="primary" loading={confirmLoading} onClick={handleOk}>
        //       {rest?.okText || '确定'}
        //     </Button>
        //   ),
        // ]}
        destroyOnClose: true,
        open: visible
    }, renderPropChildren()));
}
function createModal(params) {
    let _resolve, _reject;
    const defered = new Promise((resolve, reject)=>{
        _reject = reject;
        _resolve = resolve;
    });
    const div = document.createElement("div");
    div.setAttribute("role", "Dynamically created modal");
    document.body.appendChild(div);
    let root = null;
    function destory() {
        setTimeout(()=>{
            root === null || root === void 0 ? void 0 : root.unmount();
            document.body.removeChild(div);
            _reject("destory");
        });
    }
    /**
   * https://github.com/ant-design/ant-design/issues/23623
   * Sync render blocks React event. Let's make this async.
   */ setTimeout(()=>{
        root = (0, _client.createRoot)(div);
        root.render(/*#__PURE__*/ _react.default.createElement(App, {
            afterClose: destory,
            ...params,
            onOk: (values)=>{
                var _params_onOk;
                const Result = (_params_onOk = params.onOk) === null || _params_onOk === void 0 ? void 0 : _params_onOk.call(params, values);
                _resolve(Result || values);
                return Result;
            },
            // onFailed={async (error) => {
            //   reject(await params.onFailed?.(error));
            // }}
            onCancel: (e)=>{
                var _params_onCancel;
                (_params_onCancel = params.onCancel) === null || _params_onCancel === void 0 ? void 0 : _params_onCancel.call(params, e);
                _reject("cancel");
            }
        }));
    });
    return {
        destory,
        promise: defered
    };
}
function createFunctionWithDefaultProps(defaultParams) {
    const newFunction = (params)=>createModal({
            ...defaultParams,
            ...params
        });
    return newFunction;
}
